//+------------------------------------------------------------------+
//|                                                     Template.mq4 |
//|                                   Copyright 2016,  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, "
#property link      ""
#property version   "1.00"
#property strict

#define MAGICMA  20160816

extern string Trades             = "  ";
extern double Lots               = 0.1;
extern int TakeProfit            = 20;
extern int StopLoss              = 20;
extern int TralLevel             = 20;
extern int Power_Slow            = 15;
extern bool UseTral              = true;

string Frames             = "    ";
int Main_TimeFrame        = 15; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1
int Slow_TimeFrame        = 30; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1

string FastMA             = "   MA";
int ma0_period            = 85;
int ma0_shift             = 4;
int ma0_method            = 3; // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA;
int ma0_price             = 3; // 0-PRICE_CLOSE, 1-PRICE_OPEN, 2-PRICE_HIGH, 3-PRICE_LOW, 4-PRICE_MEDIAN, 5-PRICE_TYPICAL, 6-PRICE_WEIGHTED

string SlowMA1            = "   MA";
int ma1_period            = 70;
int ma1_shift             = 3;
int ma1_method            = 1; // 0-MODE_SMA; 1-MODE_EMA; 2-MODE_SMMA; 3-MODE_LWMA;
int ma1_price             = 5; // 0-PRICE_CLOSE, 1-PRICE_OPEN, 2-PRICE_HIGH, 3-PRICE_LOW, 4-PRICE_MEDIAN, 5-PRICE_TYPICAL, 6-PRICE_WEIGHTED

int GAP_Level=20;   //    10 
int GAP_TimeOUT                  = 10;
int GAP_Timer                    = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----
   Main_TimeFrame=Period();
   switch(Main_TimeFrame)
     {
      case PERIOD_M1:
         Slow_TimeFrame=PERIOD_M5;
         break;
      case  PERIOD_M5:
         Slow_TimeFrame=PERIOD_M30;
         break;
      case PERIOD_M15:
         Slow_TimeFrame=PERIOD_H1;
         break;
      case PERIOD_M30:
         Slow_TimeFrame=PERIOD_H4;
         break;
      case PERIOD_H1:
         Slow_TimeFrame=PERIOD_D1;
         break;
      default:
         Slow_TimeFrame=Main_TimeFrame;
         break;
     }
   if(Digits==5 || Digits==3)
     {
      TakeProfit  *=10;
      StopLoss    *=10;
      GAP_Level   *=10;
      TralLevel   *=10;
      Power_Slow  *=10;
     }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----

//----
   return;
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
  {
//----
   if(AccountEquity() <= MarketInfo(Symbol(),MODE_MARGINREQUIRED)*Lots)return; //    
   if(Bars<100 || IsTradeAllowed()==false) return;
   if(isNewBar()==false) return;   //      - 
   if(CountVsego()==0) CheckForOpen();
   else CheckForClose();
//----
   return;
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==symbol && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   //if(isNewBar()==false) return;   //      - 

   int res;

   int gap=(int)(MathAbs(Open[0]-Close[1])/Point);
   if(gap>GAP_Level) GAP_Timer=GAP_TimeOUT;

   if(GAP_Timer>0)
     {
      GAP_Timer--;
      if(GAP_Timer > 0) return;
     }

   if(Signal_Sell())
     {
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
      return;
     }

   if(Signal_Buy())
     {
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
      return;
     }
  }
//+------------------------------------------------------------------+
bool Signal_Buy()
  {
   double ma5_1 = iMA(NULL,0, 5,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, 5,0,MODE_EMA,PRICE_CLOSE,3);
   double ma75_1 = iMA(NULL,0, 75, 0, MODE_LWMA, PRICE_LOW, 1);
   double ma75_2 = iMA(NULL,0, 75, 0, MODE_LWMA, PRICE_LOW, 3);
   double ma85_1 = iMA(NULL,0, 85, 0, MODE_LWMA, PRICE_LOW, 1);
   double ma85_2 = iMA(NULL,0, 85, 0, MODE_LWMA, PRICE_LOW, 3);
   double macd_1 = iMACD(NULL,0,15,26,1,PRICE_CLOSE,MODE_MAIN,1);
   double macd_2 = iMACD(NULL,0,15,26,1,PRICE_CLOSE,MODE_MAIN,3);
   double sma0 = iCustom(NULL, Slow_TimeFrame, "NonLagMA_v5",0,1);
   double sma1 = iCustom(NULL, Slow_TimeFrame, "NonLagMA_v5",0,2);
   if(MathAbs(sma0-sma1)< Power_Slow*Point)return(false);
   if(ma5_1>ma75_1 && ma5_1>ma85_1 && ma5_2<ma75_2 && ma5_2<ma85_2 && 
      macd_1 > macd_2 && sma0 > sma1) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
bool Signal_Sell()
  {
   double ma5_1 = iMA(NULL,0, 5,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, 5,0,MODE_EMA,PRICE_CLOSE,3);
   double ma75_1 = iMA(NULL,0, 75, 0, MODE_LWMA, PRICE_LOW, 1);
   double ma75_2 = iMA(NULL,0, 75, 0, MODE_LWMA, PRICE_LOW, 3);
   double ma85_1 = iMA(NULL,0, 85, 0, MODE_LWMA, PRICE_LOW, 1);
   double ma85_2 = iMA(NULL,0, 85, 0, MODE_LWMA, PRICE_LOW, 3);
   double macd_1 = iMACD(NULL,0,15,26,1,PRICE_CLOSE,MODE_MAIN,1);
   double macd_2 = iMACD(NULL,0,15,26,1,PRICE_CLOSE,MODE_MAIN,3);
   double sma0 = iCustom(NULL, Slow_TimeFrame, "NonLagMA_v5",0,1);
   double sma1 = iCustom(NULL, Slow_TimeFrame, "NonLagMA_v5",0,2);
   if(MathAbs(sma0-sma1)< Power_Slow*Point)return(false);
   if(ma5_1<ma75_1 && ma5_1<ma85_1 && ma5_2>ma75_2 && ma5_2>ma85_2 && 
      macd_1 < macd_2 && sma0 < sma1) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void CheckForClose()
  {
//double SL,TP;
//int profit;
   //int temp1;
   bool res;
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(UseTral)
           {
            if(Bid-OrderOpenPrice()>TralLevel*Point)
              {
               if(OrderStopLoss()<Bid-TralLevel*Point)
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TralLevel*Point,OrderTakeProfit(),0,Green);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()<Bid-15*Point && OrderOpenPrice()>OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+5*Point,OrderTakeProfit(),0,Blue);
               if(res==false)
                 {
                  Print("Error Modify BUY. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()+2*Point,
                        " Bid = ",Bid," Ask = ",Ask);
                 }
              }
           }
        }
      if(OrderType()==OP_SELL)
        {
         if(UseTral)
           {
            if((OrderOpenPrice()-Ask)>TralLevel*Point)
              {
               if((OrderStopLoss()>(Ask+TralLevel*Point)))
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TralLevel*Point,OrderTakeProfit(),0,Red);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()>Ask+15*Point && OrderOpenPrice()<OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-5*Point,OrderTakeProfit(),0,Red);
               if(res==false)
                 {
                  Print("Error Modify SELL. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()-2*Point,
                        " Ask = ",Ask," Bid = ",Bid);
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|      Signal_Stop_...()          |
//+------------------------------------------------------------------+
//void CheckForClose()
//  {
//   //double SL,TP;
//   //int profit;
//   int res;
//
//   for(int i=OrdersTotal()-1; i>=0; i--)
//     {
//      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
//      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
//      //---- check order type 
//      if(OrderType()==OP_BUY)
//        {
//         if(Signal_Stop_Buy())
//           {
//            res=OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
//           }
//        }
//      if(OrderType()==OP_SELL)
//        {
//         if(Signal_Stop_Sell())
//           {
//            res=OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
//           }
//        }
//     }
//  }

//+------------------------------------------------------------------+
bool Signal_Stop_Buy()
  {
   double ma0 = iMA(NULL,Main_TimeFrame,ma0_period,ma0_shift,ma0_method,ma0_price,0);
   double ma1 = iMA(NULL,Main_TimeFrame,ma1_period,ma1_shift,ma1_method,ma1_price,0);
   if(ma0 > ma1) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
bool Signal_Stop_Sell()
  {
   double ma0 = iMA(NULL,Main_TimeFrame,ma0_period,ma0_shift,ma0_method,ma0_price,0);
   double ma1 = iMA(NULL,Main_TimeFrame,ma1_period,ma1_shift,ma1_method,ma1_price,0);
   if(ma0 < ma1) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//---         
   static datetime last_time=0;
//---  
   datetime lastbar_time=(datetime)(SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE));

//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }

//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int CountSELL()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_SELL)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
int CountBUY()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_BUY)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountVsego()
  {
   int Vsego;
   Vsego=CountBUY()+CountSELL();

   return(Vsego);
  }
//+------------------------------------------------------------------+